-- name: [CS] Iono
-- description: Iono Pokemon SV
-- category: cs

local TEXT_MOD_NAME = "Iono"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_CUSTOM_MODEL = smlua_model_util_get_id("iono_geo") -- Located in "actors"
local TEX_CUSTOM_LIFE_ICON = get_texture_info("iono_icon")
local PALETTE_CHAR = {
    [PANTS]  = "F8D2EB",
    [SHIRT]  = "C4F1F6",
    [GLOVES] = "FFFEFF",
    [SHOES]  = "E4D85A",
    [HAIR]   = "60498B",
    [SKIN]   = "FFD2D4",
    [CAP]    = "1A0C42",
}
local VOICETABLE_IONO = {
    [CHAR_SOUND_LETS_A_GO] = 'iono11.ogg', -- Starting level
    [CHAR_SOUND_PUNCH_HOO] = 'iono7.ogg', -- Punch 3
    [CHAR_SOUND_YAH_WAH_HOO] = {'iono1.ogg', 'iono2.ogg'}, -- First/Second jump sounds
    [CHAR_SOUND_HOOHOO] = 'iono12.ogg', -- Third jump sound
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'iono5.ogg', -- Triple jump sounds
    [CHAR_SOUND_UH] = 'iono14.ogg', -- Wall bonk
    [CHAR_SOUND_HAHA] = 'iono11.ogg', -- Landing triple jump
    [CHAR_SOUND_YAHOO] = 'iono12.ogg', -- Long jump
    [CHAR_SOUND_DOH] = 'iono14.ogg', -- Long jump wall bonk
    [CHAR_SOUND_WHOA] = 'iono15.ogg', -- Grabbing ledge
    [CHAR_SOUND_WAAAOOOW] = 'iono10.ogg', -- Falling a long distance
    [CHAR_SOUND_TWIRL_BOUNCE] = 'iono7.ogg', -- Bouncing off of a flower spring
    [CHAR_SOUND_GROUND_POUND_WAH] = 'iono4.ogg', 
    [CHAR_SOUND_HRMM] = 'iono1.ogg', -- Lifting something
    [CHAR_SOUND_HERE_WE_GO] = 'iono8.ogg', -- Star get
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'iono13.ogg', -- Throwing Bowser
--DAMAGE
    [CHAR_SOUND_ATTACKED] = 'iono6.ogg', -- Damaged
    [CHAR_SOUND_PANTING] = 'iono4.ogg', -- Low health
    [CHAR_SOUND_ON_FIRE] = 'iono10.ogg', -- Burned
--SLEEP SOUNDS
    [CHAR_SOUND_IMA_TIRED] = 'iono9.ogg', -- Mario feeling tired
    [CHAR_SOUND_YAWNING] = 'iono9.ogg', -- Mario yawning before he sits down to sleep
--DEATH
    [CHAR_SOUND_DYING] = 'iono9.ogg', -- Dying from damage
    [CHAR_SOUND_DROWNING] = 'iono10.ogg', -- Running out of air underwater
    [CHAR_SOUND_MAMA_MIA] = 'iono9.ogg', -- Booted out of level
}

local CSloaded = false
local function on_character_select_load()
    CT_CHAR = _G.charSelect.character_add("Iono", {"The Supercharged Streamer Iono", "is here in a new squishy forme to", "cause mischief in her Live Stream!"}, "Takkotito", {r = 255, g = 241, b = 108}, E_MODEL_CUSTOM_MODEL, CT_MARIO, TEX_CUSTOM_LIFE_ICON)
    _G.charSelect.character_add_voice(E_MODEL_CUSTOM_MODEL, VOICETABLE_IONO)
    _G.charSelect.character_add_palette_preset(E_MODEL_CUSTOM_MODEL, PALETTE_CHAR)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_IONO then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_IONO then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)